#ifndef _ping_h_
#define _ping_h_

struct icmp_header{
  char type;
  char code;
  unsigned short cksum;
  unsigned short id;
  unsigned short sn;
  char data;
};

class TraceRoute : public virtual LOB, public virtual VRschedObj, public virtual ForwarderIF
{
public:
  TraceRoute(LOBenv*);		//- the constructor 
  ~TraceRoute();		//- the desctructor 
  char *id(){return "traceroute";}
  int interrupt(VRevent*);
  int forward(Sock*, Packet *);
  VRevent *event;
  RawSock *sin;
  UDPSock *sout;
  
private:
  int hops;
  unsigned long d_addr;
  void show_help();
  int verbose;
  char testpattern[128];
};

#endif


