#ifndef _forwarder_if_h_
#define _forwarder_if_h_

#include "packet.H"

class FFilter;
class Sock;

class ForwarderIF
{
public:
  ForwarderIF(){return;}
  virtual ~ForwarderIF(){return;}
  virtual int forward(FFilter*, Packet *){return 0;}
  virtual int forward(Sock*, Packet *){return 0;}
};


typedef struct{
  unsigned long source;
  unsigned long dest;
  char zero;
  char proto;
  unsigned short pktlen;
  unsigned short datalen;
  char *data;
  Packet pkt;
} PSPacket;


class ProtocolStack
{
public:
  ProtocolStack(){return;}
  virtual ~ProtocolStack(){return;}
  virtual int process(PSPacket*) = 0;
};

#endif



