#ifndef _qcdsmarker_H_
#define _qcdsmarker_H_

#include "qco.H"

class IPNMx;

struct DSstate_Info{
  unsigned short service;
  unsigned long bw[2];
  unsigned long bs[2]; 
  double time_mark;
  unsigned long bucket_level[2];
};


class QCdsmarker : public QCO
{
public:
  QCdsmarker(QCroot*);
  ~QCdsmarker();
  char *id(){return "diffserv marker";}
  unsigned short int type_id(){return QCTYPEID_DSMARKER;}
  Packet *deque(QCO*);
  Packet *nextdeque(QCO*);
  int enque(Packet *);
  VRRB* APIconfigure(VRCB *);
private:
  int mark(Packet *);
  int nof_rules;
  unsigned long enques;		//- \# packets all over
  unsigned long newmarks;	//- \# new mark set
  unsigned long oldmarks;	//- \# same mark as before
  IPNMx *tbl; 
};

#endif


