#ifndef _qcscheduler_h_
#define _qcscheduler_h_

#include "qco.H"

#define SCHED_PRR 0
#define SCHED_WFQ 1
#define SCHED_RR  2

class QCscheduler : public QCO 
{
public:
  QCscheduler(QCroot*);
  ~QCscheduler();
  char *id(){return "scheduler";}
  unsigned short int type_id(){return QCTYPEID_SCHEDULER;}

  Packet * deque(QCO*);
  Packet *nextdeque(QCO*);
  int enque(Packet *p);
  VRRB * APIconfigure(VRCB*);

private:
  unsigned long rangen_seed;
  unsigned short rangen();
  void ins_sort();
  //  void status();
  // void clearstats();
  unsigned long *dehits;
  unsigned short *weights;
  int mode;

  // RR vars
  int rr_cnt;
 
  // WFQ vars
  int ins_choosen;
  int *idx_avail;
  Packet **pkt_avail;
};

#endif



