#include <stdlib.h>
#include <string.h>
#include "vr.H"
#include "tools.H"
#include "forwarder.H"
#include "tunnel_endpoint.H"


Tunnel_Endpoint::Tunnel_Endpoint(VR *v): ProtocolStack()
{
  vr=v;
  packet_out=(Packet*)malloc(2048);
  return;
}

Tunnel_Endpoint::~Tunnel_Endpoint()
{
  free(packet_out);
  return;
}

int Tunnel_Endpoint::process(PSPacket *psp)
{
  Packet *ep=(Packet*)PKT_DATA(&psp->pkt);
  
#ifdef DEBUG_TUNNELENDPOINT
  fhprintf(vr->cfh,"tunnel_ep: got packet '%s'\n",pkt2char(&psp->pkt)); 
  fhprintf(vr->cfh,"tunnel_ep: encapsulat '%s'\n",pkt2char(ep));
#endif

  memcpy(packet_out,ep,PKT_LENGTH(ep));
  vr->pf->distribute(NULL, packet_out);
  
  return 0;
}

