#ifndef vrevent_h_
#define vrevent_h_

class VRschedObj;

class VRevent
{
public:
  VRevent(VRschedObj *);
  VRevent();
  void clear();
  int type;			// contains flags which events are supervised
  int thrown;			// contains flags spcifying which event is triggered
  int suspended;		// contains flag specifying the suspended events  
  double suspend_time;		// how long is suspension active
  double timer_time;		// trigger timed events periodically with this interval
  double last_call;		// last call for timed events
  VRschedObj *o;
  int fh_r;
  int fh_w;
  int forced;			// force interupt call
  unsigned long event_id;
  unsigned long hits;
};

#endif
