#ifndef _senderreceiver_h_
#define _senderreceiver_h_

/*
  completely virtual, only a basclass for the simple exchange of sender
  and receiver modules
*/


class Sender {
public:
  virtual char* version() = 0 ;
  virtual int sendbuff(char *, unsigned long) = 0;
};




class Receiver {
public:
  virtual char* version() = 0;
  virtual long receivebuff(char *, long) = 0;
};


#endif
