#ifndef _anep_h_
#define _anep_h_


struct ANEP_HEADER {
  unsigned int version:8;
  unsigned int flags:8;
  unsigned int type:16;
  unsigned int hdr_length:16;
  unsigned int length:16;
};

struct ANEP_OPTION {
  unsigned option_type:14;
  unsigned flags:2;
  unsigned option_length:16;
};

#define ANEP_OPTION_LENGTH(p) ( ntohs((p)->len) )

#endif
