#ifndef _ffilter_h_
#define _ffilter_h_

#define FFILTER_MODE_COPY    0
#define FFILTER_MODE_MOVE    1

class ForwarderIF;
class Packet;

class FFilter
{
public:
  FFilter();
  int matches(Packet*);
  int equals(FFilter*);
  int prio;
  ForwarderIF *forwarder;
  unsigned long source_ip;	// 0 to ignore
  unsigned long source_nm;	
  unsigned long dest_ip;	// 0 to ignore
  unsigned long dest_nm;
  unsigned int tos;		// 0xffff to ignore
  unsigned int proto;		// 0xffff to ignore
  int ipopt_type;		// 0 to ignore
  unsigned long ipopt_value;
  int mode;
  int flags;
  char name[32];
  unsigned short cb_handle;	// the handle of the VRCB
};


#endif






