#include <stdlib.h>
#include <unistd.h>
#include "config.H"
#include "ioc.H"

IOchannel::IOchannel()
{
  options=0;
  pipe(p);
  level=0;
  return;
}

IOchannel::~IOchannel()
{
  close(p[0]);
  close(p[1]);
  return;
}

int IOchannel::send(char *s, int n)
{
  int k=write(p[1],s,n);
  if(k>0)level+=k;
  return k;
}

int IOchannel::recv(char *s, int n)
{
  if(!level && (options&IO_NONBLOCK))return 0;
  int k=read(p[0], s, n);
  if(k>0)level-=k;
  return k;
}


int IOchannel::setopt(int o)
{
  options|=o;
  return options;
}



