#ifndef _qcdroptail_h_
#define _qcdroptail_h_

#include "qco.H"

class QCdroptail : public QCO
{
public:
  QCdroptail(QCroot*, int n=8192);
  ~QCdroptail();

  char *id(){return "droptail";}
  unsigned short int type_id(){return QCTYPEID_DROPTAIL;}
  Packet * deque(QCO *);
  Packet * nextdeque(QCO*);
  int enque(Packet *p);
  int can_enque(Packet *);
  VRRB* APIconfigure(VRCB *);

private: 
  unsigned long drops;
  unsigned long deempty;
  unsigned long dehits;
  unsigned long dereq;
  int nof_pkts; 
  int max_nof_pkts;
  int en_idx;
  int de_idx;
  Packet **pkts;
  int extended_drop_decision(Packet*);
  double ext_ql;
};


#endif
